/******************************************************************************\

  Copyright 2005 The University of North Carolina at Chapel Hill.
  All Rights Reserved.

  Permission to use, copy, modify and distribute this software and its
  documentation for educational, research and non-profit purposes, without
  fee, and without a written agreement is hereby granted, provided that the
  above copyright notice and the following three paragraphs appear in all
  copies. Any use in a commercial organization requires a separate license.

  IN NO EVENT SHALL THE UNIVERSITY OF NORTH CAROLINA AT CHAPEL HILL BE LIABLE
  TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
  DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND
  ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF NORTH CAROLINA HAVE BEEN
  ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


  Permission to use, copy, modify and distribute this software and its
  documentation for educational, research and non-profit purposes, without
  fee, and without a written agreement is hereby granted, provided that the
  above copyright notice and the following three paragraphs appear in all
  copies.

  THE UNIVERSITY OF NORTH CAROLINA SPECIFICALLY DISCLAIM ANY WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
  "AS IS" BASIS, AND THE UNIVERSITY OF NORTH CAROLINA HAS NO OBLIGATION TO
  PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.


   ---------------------------------
  |Please send all BUG REPORTS to:  |
  |                                 |
  |   sungeui@cs.unc.edu            |
  |                                 |
   ---------------------------------


  The authors may be contacted via:

  US Mail:         Sung-Eui Yoon or Dinesh Manocha
                       Department of Computer Science
                       Sitterson Hall, CB #3175
                       University of North Carolina
                       Chapel Hill, NC 27599-3175

\*****************************************************************************/


// include header
#include "OpenCCL.h"

// enable name space
using namespace OpenCCL;


int main (int argc, char * argv [])
{
	printf (" A sample mesh: 	\n");
	printf (" 0	--	1 	\n");
	printf (" |	\\	|	\n");	
	printf (" 2	__	3	\n");	

	// Specify the number of vertex
	const int NumVertex = 4;	
	int Order [NumVertex];

	CLayoutGraph Graph (NumVertex);

	// make edges between vertices
	Graph.AddEdge (0, 1);
	Graph.AddEdge (0, 2);
	Graph.AddEdge (0, 3);
	
	Graph.AddEdge (1, 3);
	Graph.AddEdge (2, 3);


	// Get ordering of the vertices
	Graph.ComputeOrdering (Order);


	printf ("Computed vertex order:\n");
	int i;
	for (i = 0;i < NumVertex;i++)
		printf ("ID of %dth position in the computed order is %d\n", i, Order [i]);	

	return 1;
}



